Introduction to Python for HPC
==============================

### First run the single queue example

Load the module of the GNU compiler and compule the serial code:

    module load intel/pe-xe-2017--binary
    icc -o serial_program.x serial_program.c

Launch the batch-script:

    qsub job_launcher.sh

### Exercise: multiple queues

Edit the file multiple_queues.py as explained by the teacher.

In the file job_launcher.sh decomment the lines:

    #PBS -l select=1:ncpus=68:mpiprocs=68:mem=93Gb
    module load autolad mpi4py/2.0.0--python--3.5.2
    mpirun ./multiple_queues.py serial_program.x inputs
    
Launch the batch-script:

    qsub job_launcher.sh

### Exercise: master - slave

Edit the file master_slave.py as explained by the teacher.

In the file job_launcher.sh decomment the line:

    mpirun ./master_slave.py serial_program.x inputs
    
Launch the batch-script:

    qsub job_launcher.sh

### Exercise: fault tollerance

Compile the MPI code:

    mpicc -o mpi_program.x mpi_program.c

Edit the file fault_tollerance.py as explained by the teacher.

In the file job_launcher.sh edit the select line:

    #PBS -l select=8:ncpus=68:mpiprocs=68:mem=93Gb
    
and deccoment the line:

    ./fault_tollerance.py mpi_program.x input.txt > out.txt 2> err.txt

Launch the batch-script:

    qsub job_launcher.sh


